-- Yoshi's Crafted World (modified bin) --
-- by DNA


checksum = require("lib.checksum")


saveFileBuffer = edizon.getSaveFileBuffer()
	


function getValueFromSaveFile()
	strArgs = edizon.getStrArgs()
	intArgs = edizon.getIntArgs()
	indirectAddress = tonumber(strArgs[1], 16)
	address = tonumber(strArgs[2], 16)
	addressSize = intArgs[1]
	valueSize = intArgs[2]
	
	offset = 0
	value = 0
		
	if indirectAddress ~= 0 then
		for i = 0, addressSize - 1 do
			offset = offset | (saveFileBuffer[indirectAddress + i + 1] << i * 8)
		end
	end
		
	for i = 0, valueSize - 1 do
		value = value | (saveFileBuffer[offset + address + i + 1] << i * 8)
	end
	
	return value
end

function setValueInSaveFile(value)
	strArgs = edizon.getStrArgs()
	intArgs = edizon.getIntArgs()
	indirectAddress = tonumber(strArgs[1], 16)
	address = tonumber(strArgs[2], 16)
	addressSize = intArgs[1]
	valueSize = intArgs[2]
	
	offset = 0
	
	if indirectAddress ~= 0 then
		for i = 0, addressSize - 1 do
			offset = offset | (saveFileBuffer[indirectAddress + i + 1] << (i * 8))
		end
	end
		
	for i = 0, valueSize - 1 do
		saveFileBuffer[offset + address + i + 1] = (value & (0xFF << i * 8)) >> (i * 8)
	end
end



function setChecksum()
	gameFileBuffer = {}
	
	--address = 1
		for i = 5,0x1000C do
			gameFileBuffer[i-4] = saveFileBuffer[i]			
--			address = address+1
		end
		

	
	
				crc = checksum.crc32(string.char(table.unpack(gameFileBuffer)))
				
--				inverted = swap32((crc & (0xFF000000 >> (i * 8))) >> (24 - i * 8))
   
		for i = 0, 3 do                                           
		saveFileBuffer[i+1] = (crc & (0xFF000000 >> (24 - i * 8))) >> ( i * 8)
		end
--saveFileBuffer[1] = ((crc & 0xFF) << 24)
--saveFileBuffer[2] = ((crc & 0xFF00) << 8)
--saveFileBuffer[3] = ((crc >> 8) & 0xFF00)
--saveFileBuffer[4] = ((crc >> 24) & 0xFF)
	
	
end


function getModifiedSaveFile()
	setChecksum()
	return saveFileBuffer
end